/* Language Abstraction Editor ver.0.1.0
 * 
 * This software is in the public domain.
 * There are no restrictions on any sort of usage of this software.
 * 
 * $lae: laetree.cpp,v 1.4.2 2001/09/18 15:39:21 Toshihiro Inoue Exp $
 */

#include "laetree.h"

#include <vector>
using namespace std;

FXDEFMAP(LAETree) LAETreeMap[] = {
  FXMAPFUNC(SEL_COMMAND, LAETree::ID_EDITEND , LAETree::onEditEnd),
};

FXIMPLEMENT(LAETree, FXTreeEditor, LAETreeMap, ARRAYNUMBER(LAETreeMap))


void LAETree::__init_class__()
{
}


LAETree::LAETree(FXComposite* p, FXint nvis, FXObject* tgt /*= NULL*/, FXSelector sel /*= 0*/, FXuint opts /*= 0*/, FXint x /*= 0*/, FXint y /*= 0*/, FXint w /*= 0*/, FXint h /*= 0*/): FXTreeEditor(p, nvis, tgt, sel, opts, x, y, w, h)
{
  __init_class__();
  
}


LAETree::~LAETree()
{
}


LAETree::LAETree()
{
  __init_class__();
  
}


long LAETree::onEditEnd(FXObject* sender, FXSelector sel, void* ptr)
{
  int i = 0;
  FXString sign;
  FXString* text = 0;
  int len = 0;
  char ch = 0;
  FXString str;
  int type = 0;
  int oldt = 0;
  vector<FXString> list;
  int sz = 0;
  FXString res;
  
  text = (FXString*)ptr;
  len = text->length();
  for(i = 0; i <= len; i++) {
    ch = (*text)[i];
    oldt = type;
    if(ch == ' ' || ch == '\0') {
      type = 0;
    } else if(('A' <= ch && ch <= 'Z') || ('a' <= ch && ch <= 'z') || ch == '_') {
      type = 1;
    } else if(('0' <= ch && ch <= '9') || ch == '.') {
      if(type != 1) type = 2;
    } else {
      type = 3;
    }
    if(type != oldt && !str.empty()) {
      list.push_back(str);
      str.clear();
    }
    if(type != 0) str += ch;
  }
  
  sz = list.size();
  for(i = 0; i < sz; i++) {
    if(i > 0 && list[i - 1] != "!" && list[i] != "++" && list[i] != "--") res += ' ';
    res += list[i];
  }
  if(*text != res) *text = res;
  return 1;
}
