/* Language Abstraction Editor ver.0.1.0
 * 
 * This software is in the public domain.
 * There are no restrictions on any sort of usage of this software.
 * 
 * $lae: laewin.h,v 1.19.9 2001/09/18 15:39:21 Toshihiro Inoue Exp $
 */

#ifndef _LAEWIN_H_
#define _LAEWIN_H_

class LAETree;

#include <fx.h>


class LAEWin: public FXTopWindow
{
public:
  FXDECLARE(LAEWin)

public:
  enum {
    ID_NEW = FXTopWindow::ID_LAST,
    ID_OPEN,
    ID_SAVE,
    ID_SAVEAS,
    ID_ABOUT,
    ID_TAB,
    ID_TREE,
    ID_LAST
  };
  
public:
  LAEWin(FXApp* app);
  virtual void create();
  virtual ~LAEWin();
  long onClose(FXObject* sender, FXSelector sel, void* ptr);
  FXString execDlg(const FXString& title, FXbool save = false);
  long onMnuNew(FXObject* sender, FXSelector sel, void* ptr);
  long onMnuOpen(FXObject* sender, FXSelector sel, void* ptr);
  void open(const FXString& fn);
  long onMnuSave(FXObject* sender, FXSelector sel, void* ptr);
  FXbool save();
  long onMnuSaveAs(FXObject* sender, FXSelector sel, void* ptr);
  FXbool saveAs();
  long onMnuAbout(FXObject* sender, FXSelector sel, void* ptr);
  long onSetCurrent(FXObject* sender, FXSelector sel, void* ptr);
  FXString genC(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString genPerl(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transPerl(const FXString& text);
  FXString genPython(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transPython(const FXString& text);
  FXString genRuby(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transRuby(const FXString& text);
  FXString genVB(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transVB(const FXString& text);
  FXString genPascal(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transPascal(const FXString& text);
  FXString genTcl(FXTreeItem* item, const FXString& indent = "", const FXString& prefix = "");
  FXString transTcl(const FXString& text);
  
protected:
  LAEWin();
  
private:
  void __init_class__();
  void initIcon();
  void initTab();
  void initMenu();
  void initTool();
  
protected:
  FXString fileName;
  FXToolbarShell* tshMenu;
  FXMenubar* menu;
  FXMenuPane* mnuFile;
  FXMenuPane* mnuEdit;
  FXMenuPane* mnuItem;
  FXMenuPane* mnuHelp;
  FXToolbarShell* tshTool;
  FXToolbar* tool;
  FXTabBook* tab1;
  FXTabItem* tab1i1;
  LAETree* tree;
  FXTabItem* tab1i2;
  FXText* codeC;
  FXTabItem* tab1i3;
  FXText* codePerl;
  FXTabItem* tab1i4;
  FXText* codePython;
  FXTabItem* tab1i5;
  FXText* codeRuby;
  FXTabItem* tab1i6;
  FXText* codeVB;
  FXTabItem* tab1i7;
  FXText* codePascal;
  FXTabItem* tab1i8;
  FXText* codeTcl;
  FXStatusbar* status;
};

#endif // _LAEWIN_H_
